<template>
  <div class="app-container">
    <!-- 查询和其他操作 -->
    <div class="filter-container" style="margin: 10px 0 10px 0;">
      <el-form :inline="true" label-width="68px" style="margin-bottom: 8px;">
        <el-col :span="18">
          <el-form-item label="项目名称 ">
            {{projectName}}
          </el-form-item>
        </el-col>
        <el-col :span="12">
          <el-button class="filter-item" type="primary" @click="handleAdd" icon="el-icon-edit">新增用戶等级</el-button>

        </el-col>
      </el-form>
    </div>

    <el-table :data="tableData" style="width:100%" class="show_table" >

      <el-table-column label="用戶等级ID" width="200" align="center">
        <template slot-scope="scope">
          <span>{{ scope.row.levelId }}</span>
        </template>
      </el-table-column>

      <el-table-column label="用戶等级名称" width="300" :show-overflow-tooltip="true" align="left">
        <template slot-scope="scope">
          <span>{{ scope.row.levelName }}</span>
        </template>
      </el-table-column>

      <el-table-column label="操作" min-width="80" fixed="right" align="center">
        <template slot-scope="scope">
            <el-button @click="handleEdit(scope.row)"  type="primary" size="small">编辑</el-button>
            <el-button @click="handleDelete(scope.row)" type="danger" size="small">删除</el-button>
        </template>
      </el-table-column>
    </el-table>

    <!--分页-->
    <div class="block">
      <el-pagination
        @size-change="handleSizeChange"
        @current-change="handleCurrentChange"
        :current-page.sync="currentPage"
        :page-sizes="[40, 80, 120, 200]"
        :page-size="pageSize"
        layout="total, prev, pager, next, jumper, sizes"
        :total="total"
      ></el-pagination>
    </div>
    <!-- 添加或修改对话框 -->
    <el-dialog :title="title" :visible.sync="dialogFormVisible" width="50%" :before-close="handleClose" center>
      <el-form :model="form" :rules="rules" ref="form" label-width="auto">
        <el-form-item label="用戶等级ID" :label-width="formLabelWidth" oninput ="value=value.replace(/[^\d]/g,'')"  prop="levelId">
          <el-input v-model="form.levelId"  style="width:80%"></el-input>
        </el-form-item>
        <el-form-item label="用戶等级名称" :label-width="formLabelWidth" prop="levelName">
          <el-input v-model="form.levelName"  style="width:80%"></el-input>
        </el-form-item>
        <el-form-item label="" :label-width="formLabelWidth" prop="source">
          <el-input v-model="form.source" style="width:80%" hidden></el-input>
        </el-form-item>
        <el-form-item label="" :label-width="formLabelWidth" prop="uid">
          <el-input v-model="form.uid" style="width:80%" hidden></el-input>
        </el-form-item>

      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button @click="handleClose">取 消</el-button>
        <el-button type="primary" @click="submitForm">确 定</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import {
  getBooksUserLevelList,
  addBooksUserLevel,
  editBooksUserLevel,
  deleteBooksUserLevel,
} from "@/api/booksUserLevel";

export default {
  data() {
    return {

      queryParams:{//查询参数
        source: "",
      },
      projectName:"",
      source: "",
      tableData: [],

      form: {
        uid: null,
        levelId: null,
        levelName: null,
        source: null,
      },
      rules: {
        levelName: [
          {required: true, message: '用户等级名称需有值', trigger: 'blur'},
        ]
      },
      dialogFormVisible: false,
      isEditForm: false,
      isAddForm: false,
      currentPage: 1,
      pageSize: 40,
      total: 0, //总数量
      orderByDescColumn: "", // 降序字段
      orderByAscColumn: "", // 升序字段
      dialogVisible: false,
    };
  },
  created() {
    this.booksUserLevelList();
  },
  methods: {
    booksUserLevelList: function() {
      this.source = this.$route.query.source;
      this.projectName = this.$route.query.projectName;
      this.queryParams.source=this.source;
      this.queryParams.currentPage = this.currentPage;
      this.queryParams.pageSize = this.pageSize;
      this.queryParams.orderByDescColumn = this.orderByDescColumn
      this.queryParams.orderByAscColumn = this.orderByAscColumn
      getBooksUserLevelList(this.queryParams).then(response => {
        this.tableData = response.data.records;
        this.currentPage = response.data.current;
        this.pageSize = response.data.size;
        this.total = response.data.total;
      });
    },
    handleAdd: function() {
      this.title = "新增用戶等级"
      this.dialogFormVisible = true;
      this.form = this.getFormObject();
      this.isEditForm = false;
      this.isAddForm = true;
    },
    handleEdit: function(row) {
      this.title = "编辑用戶等级";
      this.dialogFormVisible = true;
      this.isEditForm = true;
      this.isAddForm = false;
      this.form = row;
    },
    handleDelete: function(row) {
      var that = this;
      this.$confirm("此操作将把用户等级删除, 是否继续?", "提示", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning"
      })
        .then(() => {
          deleteBooksUserLevel(row).then(response => {
            if(response.code == this.$ECode.SUCCESS) {
              this.$commonUtil.message.success(response.message)
            } else {
              this.$commonUtil.message.error(response.message)
            }
            this.booksUserLevelList();
          });
        })
        .catch(() => {
          this.$commonUtil.message.info("已取消删除")
        });
    },
    submitForm: function() {
      this.$refs.form.validate((valid) => {
        if(!valid) {
          console.log("校验出错")
        } else {
          if (this.isEditForm) {
            editBooksUserLevel(this.form).then(response => {
              this.$commonUtil.message.success(response.message)
              this.dialogFormVisible = false;
              this.booksUserLevelList();
            });
          } else {
            addBooksUserLevel(this.form).then(response => {
              if (response.code == this.$ECode.SUCCESS) {
                this.$commonUtil.message.success(response.message)
              } else {
                this.$commonUtil.message.error(response.message)
              }
              this.dialogFormVisible = false;
              this.booksUserLevelList();
            });
          }
        }
      })
    },
    handleFind: function() {
      this.currentPage = 1
      this.booksUserLevelList();
    },
    getFormObject: function() {
      var formObject = {
        uid: null,
        levelId: null,
        levelName:null,
        status: 1,
        source: this.source,
      };
      return formObject;
    },
    handleClose(){
      this.dialogFormVisible = false;
      this.$refs.form.clearValidate();
      this.booksUserLevelList();
    },

    /**
     * 翻页事件
     */
    handleSizeChange(val) {
      this.pageSize = val;
      this.booksUserLevelList();
    },
    handleCurrentChange: function(val) {
      this.currentPage = val;
      this.booksUserLevelList();
    },

  }
};
</script>
<style scoped>
  .el-form-item {
    margin-bottom: 16px;
  }
</style>
